/*
* $Id: BinClock.c,v 1.2 2002/04/17 21:26:14 ldrolez Exp $
*
* Danny H. Newport

* compiled with AvrEdit Ver. 3.5 using 61% memory (room for expansion)
*
*
*   This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.   
*
*
*	Special Thanks.
*		AVR GCC team for a great compiler
*		AvrEdit for a great avr ide setup
*		Ludovic Drolez for the SSC opensource code
*		Atmel for the versitile Micro.    
* 
*/

#include <io.h>
#include <interrupt.h>
#include <sig-avr.h>
#include <timer.h>
#define __AVR_AT90S8515__

//defines for delay
#define CPU_freq   20000000						//cpu clock frequency
#define CYCLES_PER_US ((CPU_freq+500000)/1000000) 	// cpu cycles per microsecond
#undef ECHO
#define UART_BAUD_RATE 9600
#define UART_BAUD_SELECT ((CPU_freq/(UART_BAUD_RATE*16))-1)

int led[20]={PINA4,PINA5,PINA6,PINA7,PINA1,PINA2,PINA3,PINB4,PINB5,PINB6,PINB7,PINB1,PINB2,PINB3,PINC3,PINC4,PINC5,PINC1,PINC2,PINC6};
typedef unsigned char  u08;
/* global variables used by PWM outputs */

/* uart globals */
//static volatile u08 *uart_data_ptr;
//static volatile u08 uart_counter;

/* global variables for delay functions */
uint16_t delay_count=CPU_freq/4000;				// used in delay function

/* prototypes */
//void dobuffer (void);

/* global variables for serial port */
//static uint8_t recv_bytes = 0;
//static char buffer[10];
volatile uint8_t ready = 0;
u08 thour;
u08 hour;
u08 tmin;
u08 min;
u08 tsec;
u08 timeprefInt;
u08 sec;
u08 loop;
u08 display[20]={0};

/*
* Set default values
*/
void init(void)
{
	/* all outputs = pwm */
	
	/* all outputs low */
	//memset (pwm, 0x00, 8);
	thour=1;
        hour=1;
        tmin=3;
        min=5;
        tsec=5;
        sec=3;
        loop=0;
        timeprefInt=12;
					
}

/*
* Convert an ASCII char to a 4 bits value
*/
uint8_t quartet (char c)
{
	/* to upper case */
	if (c >= 'a')
		c = c - 32;
	if (c < 'A')
		return (c - '0');
	else
		return (c - 'A' + 10);
}

char tobcd (uint8_t i)
{
	if (i > 9)
		return (i + 'A' - 10);
	else
		return (i + '0');
}

/*
 * uart transmit complete isr
 */
INTERRUPT (SIG_UART_TRANS)
{
  ready = 1;


}

/*
*  wait for serial buffer to clear
*/
void pause (void)
{
	while (!ready);
	ready = 0;
}




// millisecond delay function
void delay_ms(uint8_t ms)
{
	uint16_t cnt; asm volatile (

		"\n" "L_dl1%=:" "\n\t" "mov %A0, %A2" "\n\t" "mov %B0, %B2" "\n" "L_dl2%=:" "\n\t"

		"sbiw %A0, 1" "\n\t" "brne L_dl2%=" "\n\t" "dec %1" "\n\t" "brne L_dl1%=" "\n\t" : "=&w" (cnt) : "r" (ms), "r" (delay_count) );
}

/*
*  function for endless loop
*/
void main_loop (void)
{
	

     //outp ('g', UDR);
 pause ();
 delay_ms(100);
       /* sbi(PORTB,PINB0);
        cbi(PORTB,PINB1);
        sbi(PORTB,PINB2);
        cbi(PORTB,PINB3);
        sbi(PORTB,PINB4);
        cbi(PORTB,PINB5);
        sbi(PORTB,PINB6);
        cbi(PORTB,PINB7);
*/
    for (;;)
    {

  

        //TimSecondsToDateTime(TimGetSeconds(),&dateTime);
        sec+=1;
        if(sec>59)
         sec=1;

        if(sec<10)
         tsec = 0;        
        if(sec>9&&sec<20)
        {
         tsec = 1;
         sec = sec-10;        
         }
         if(sec>19&&sec<30)
         {
        
         tsec = 2;
         sec = sec-20;        
         }
         
        if(sec>29&&sec<40)
        {
         tsec = 3;
         sec = sec-30;        
         }
        if (sec>39&&sec<50)
        {
         tsec = 4;
         sec = sec-40;        
         }
         if(sec>49)
         {
         tsec = 5;
         sec = sec-50;
         }
 
       if(sec==0)
        min++;
       // min = dateTime.minute;
        
        if(min<10)
         tmin = 0;        
        if(min>9&&min<20)
        {
         tmin = 1;
         min = min-10;        
         }
         if(min>19&&min<30)
         {
        
         tmin = 2;
         min = min-20;        
         }
         
        if(min>29&&min<40)
        {
         tmin = 3;
         min = min-30;        
         }
        if (min>39&&min<50)
        {
         tmin = 4;
         min = min-40;        
         }
         if(min>49)
         {
         tmin = 5;
         min = min-50;
         }
         
         
        //hour = dateTime.hour;
        hour = 13;
        if(hour==0 && timeprefInt==12) //if hour is 0 and prefs are 12hr, then change hour to 12
            hour=12;
            
        if(hour>=13)
            hour=hour - timeprefInt;
        
        if(hour<10)
         thour = 0;        
        if(hour>9&&hour<20)
        {
         thour = 1;
         hour = hour-10;        
         }
         if(hour>19&&hour<30)
         {
        
         thour = 2;
         hour = hour-20;        
         }
         
      
        for(loop=0;loop<20;loop++)
        {
            display[loop]=0;
        }
  
                if(sec>7)
                {
                 display[3]=1;
                 
                 }
                if(sec>3&&sec<8)
                {
                display[2]=1;
                 }
                if(sec==2||sec==3||sec==6||sec==7)
                {
                display[1]=1;
                }                
                if(sec==1||sec==9||sec==3||sec==5||sec==7)
                {
                display[0]=1;
                 
                 }
          
           
              
                if(tsec>3&&tsec<8)
                {
                display[6]=1;
                 }
                if(tsec==2||tsec==3||tsec==6||tsec==7)
                {
                display[5]=1;
                }                
                if(tsec==1||tsec==9||tsec==3||tsec==5||tsec==7)
                {
                display[4]=1;
                 
                 }
           
           
            
           
                if(min>7)
                {
                display[10]=1;
                 }
                if(min>3&&min<8)
                {
                display[9]=1;
                 }
                if(min==2||min==3||min==6||min==7)
                {
                display[8]=1;
                 }                
                if(min==1||min==9||min==3||min==5||min==7)
                {
                display[7]=1;
                
                 }
            

                if(tmin>3&&tmin<8)
                {
                display[13]=1;
                 }
                if(tmin==2||tmin==3||tmin==6||tmin==7)
                {
                display[12]=1;
                 }                
                if(tmin==1||tmin==9||tmin==3||tmin==5||tmin==7)
                {
                display[11]=1;
                 
                 }
             
               if(hour>7)
                {
                display[17]=1;
                 }
                if(hour>3&&hour<8)
                {
                display[16]=1;
                 }
                if(hour==2||hour==3||hour==6||hour==7)
                {
                display[15]=1;
                 }                
                if(hour==1||hour==9||hour==3||hour==5||hour==7)
                {
                display[14]=1;
                 
                 }
                       
             
           
              if(thour>1&&thour<3)
              {
              display[19]=1;
    
              }
              if(thour==1)
              {
              display[18]=1;
              
              }   
           
        for(loop=0;loop<20;loop++)
        {
                 if(display[loop]==1)
                 {
                         sbi(PORTB,led[loop]);
 
                 }
                 else
                 {
                      cbi(PORTB,led[loop]);
                 
                 
                 }

      
        }


    }
		
		
	
}



/*
*
*/
int
main (void)
{
	init();
	/* 10Mhz / 200 = 1 overflow every 20,0 us @ 10MHz */
	/* 255 steps = 5.1 ms */
	outp (0xff, DDRA);			/* portb = input */
	outp (0xff, DDRB);			/* portd = input */
	outp (0xff, DDRC);			/* portb = input */
	outp (0x00, DDRD);			/* portd = input */

	outp ((1 << TXCIE) | (1 << RXEN) | (1 << TXEN), UCR);
	outp (64, UBRR);
     
	sei ();						/* enable interrupts */
	main_loop ();
        return 0;
}


/*void delay_ms(char delay_time)
{
int c;
for(c = 0; c < (CPU_freq / 40000); c++)
{
}
}*/

/*// microsecond delay function
void delay_us(unsigned short us)
{
unsigned short  delay_loops;
register unsigned short  i;

  delay_loops = (us+3)/5*CYCLES_PER_US; // +3 for rounding up (dirty)

	// one loop takes 5 cpu cycles
	for (i=0; i < delay_loops; i++) {};
}*/
